globals [
  ;p-increase
  scope
]

turtles-own [
  picky ;allowable distance between your average scores
  ability ;how smart you are
  popularity ;how cool you are
  no-match? ;if you have a partner or not...true = no partner, false = partner
  buddy
]

links-own[
  av-ability
  av-pop
  dif-ability
  dif-pop
]

to setup
  clear-all
  reset-ticks
  let yrepeat 2
  let xrepeat 2
  let yoffset 6
  let xoffset -10
  repeat rows [
    repeat columns [ create-turtles 1 [ ;;one of Nathan's suggestions was to put them into 'desk' formation, it made it easier to have them pick a turtle
    set shape "person"
    set ycor (yrepeat + yoffset)
    set xcor (xrepeat + xoffset)
    set xrepeat (xrepeat + 2)
    set picky 0
    set ability random 10
    set popularity random 10
    set no-match? true
    set color scale-color 40 (ability + 1) 0 10];sets the color of the turtles according to ability level. 
    ;The first number is the color that is shaded
  ]
    set yrepeat (yrepeat - 2)
    set xrepeat 2
  ]
  ;set p-increase .1
  set scope 2
end

to go
  if all? turtles [no-match? = false]
  [stop]
  ask turtles [ 
    set picky (picky + p-increase) 
    ]
  ask turtles [
    if no-match? ;ifelse no-match?
    [find-partner] ;true - search for partners
    ;[set shape "face happy"] ;false - have a partner, change shape is just so we can see it for now
  ]
set scope (scope + 2) ;look further out for a partner
tick 
end

to find-partner
  let close-turtle one-of other turtles with [distance myself <= scope and no-match? = true] ;pick one that's close and doesn't already have a partner
  let your-score (([ability] of close-turtle + [popularity] of close-turtle) / 2)
  let my-score ((ability + popularity) / 2)
  if abs (your-score - my-score) <= picky ;this should be the same for both, right?  they should each have the same pickyness, and the abs difference between their mean scores should be the same?
  [set no-match? false ;I have a partner
    set buddy close-turtle ;sets who the turtle's partner is
    ask close-turtle [ ;you have a partner
      set no-match? false
      set buddy myself] ;sets who the matched turtle's partner is
  ]
  ifelse no-match? = false and [no-match?] of close-turtle = false ;if we are both ok with matching
  [partner] ;then we become partners and do something TBD
  [set no-match? true ask close-turtle [set no-match? true] ] ;if not, we both go back to being partnerless
end

to partner
  ;set color black this is a place holder - still need to figure out what we want them to do. half of them turn black and their partner becomes a smiley face in the go procedure
  ;;maybe they could draw a line to their partner?  what would be a useful thing to see?
;move-to buddy
;fd 1
set shape "face happy"
create-link-with buddy
ask link-with buddy 
  [set av-ability (([ability] of end1 + [ability] of end2) / 2)
    set av-pop (([popularity] of end1 + [popularity] of end2) / 2)
    set dif-ability abs (([ability] of end1 - [ability] of end2) / 2)
    set dif-pop abs (([popularity] of end1 - [popularity] of end2) / 2)
    set color scale-color 111 (dif-ability + 1) 7 0
      ] ;links with greater difference in ability are darker colors
;sets background color according to average ability + popularity
set pcolor scale-color 90 ((ability + [ability] of buddy + 1) / 2) 0 10 ;lighter blue means higher average ability
ask buddy [
  set pcolor scale-color 20 ((popularity + [popularity] of buddy + 1) / 2) 0 10 ;lighter orange means higher average popularity
  set shape "face happy"
]
end


to-report number-paired
  report count turtles with [no-match? = false]
  ;histogram-from links [dif-ability]
  ;histogram-from links [dif-popularity] 
end

;;do we want to add any sliders?
@#$#@#$#@
GRAPHICS-WINDOW
210
10
649
470
16
16
13.0
1
10
1
1
1
0
1
1
1
-16
16
-16
16
1
1
1
ticks
30.0

BUTTON
20
62
86
95
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
111
62
174
95
Go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
3
255
170
300
Number of Turtles Paired
number-paired
0
1
11

PLOT
4
307
204
457
Turtles Paired over Time
Time
Number of turtles paired
0.0
30.0
0.0
30.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot number-paired"

PLOT
218
477
418
627
Difference in Ability of Pairs
Difference
Number of Pairs
0.0
10.0
0.0
15.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "histogram [dif-ability] of links"

PLOT
446
476
677
626
Difference in Popularity of Pairs
NIL
NIL
0.0
10.0
0.0
15.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "histogram [dif-pop] of links"

SLIDER
17
12
189
45
p-increase
p-increase
.01
.2
0.03
.01
1
NIL
HORIZONTAL

SLIDER
15
114
187
147
rows
rows
2
8
8
2
1
NIL
HORIZONTAL

SLIDER
18
169
190
202
columns
columns
1
9
9
1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

This is a model of how students might pair up in a classroom. Currently, students try to find someone close to them that has a similar ability and popularity. As time goes on, students get less picky and will accept poorer matches. The students are colored according to ability, with the higher-ability students being a lighter shade of yellow.

## HOW IT WORKS

The students try to pair with close-by students. They will pair up with a student as long as the average difference between their qualities (ability and popularity) is less than their pickiness. The pickiness of the students decreases over time, and the distance they will look for a partner increases over time. 

When two students are paired, they turn into smiley faces, and a link between them is created. The link is shaded based on their difference in ability. Larger differences in ability have darker colors. The blue patch behind one of the students matched shows the average ability of the pair (lighter is higher average). The orange patch behind one of the students matched shows the average popularity of the pair (lighter is higher average). 

## HOW TO USE IT

To set up the "students" in the class, click the setup button. The model runs after the go button is clicked. The number of students paired and a graph of the number are shown on the left. Histograms of the differences in the characteristics of the students are shown at the bottom.

## THINGS TO NOTICE

Students seem to be able to pair pretty well such that there are no huge differences in ability or popularity in pairs. 

## THINGS TO TRY

Try changing how quickly the pickiness decreases.

## EXTENDING THE MODEL

One way to extend the model is to create new rules for pairings. One idea we came up with was to try to pair up with someone who is more popular or has a higher ability than you. 

Another way to extend the model would be to include a teacher that randomly walks around between students and pairs them up with the student next to them.

## NETLOGO FEATURES

We decided to model a pairing by linking two turtles together, so we used the primitive link in our model.

## RELATED MODELS

This model may be similar to many network models.

## CREDITS AND REFERENCES

Created by Stina and Elizabeth
(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0RC7
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
